// Voorbeeld van een test-sketch voor verschillende DHT vochtigheid/temperatuur sensoren.
// Geschreven door ladyada, publiek domein.

#include <LiquidCrystal.h>
#include "DHT.h" // Roep de DHT-bibliotheek aan
#define DHTPIN 8 // Pen verbonden met DHT
LiquidCrystal lcd(12, 11, 5, 4, 3, 2);
#define DHTTYPE DHT11 // Definieer het type DHT-module
DHT dht(DHTPIN, DHTTYPE); // Commando voor de DHT.h-bibliotheek
void setup() {
  dht.begin(); // Start de sensor
  lcd.begin(16, 2); // Lcd-scherm is 16 tekens maal 2 regels
}
void loop() {
  float h = dht.readHumidity(); // Waarde voor vochtigheid
  float t = dht.readTemperature(); // Waarde voor temperatuur
  t = t * 9 / 5 + 32; // Verander uitgelezen waarde van Celcius naar Fahrenheit
  if (isnan(t) || isnan(h)) { // Controleer of DHT-sensor werkt
    lcd.setCursor(0, 0);
    lcd.print("Failed to read from DHT"); // Als DHT niet werkt,
    // toon dit
  } else { // Toon anders de uitgelezen waarden op het scherm
    lcd.clear();
    lcd.setCursor(0, 0);
    lcd.print("Humidity: ");
    lcd.print(h);
    lcd.print("%");
    lcd.setCursor(0, 1);
    lcd.print("Temp: ");
    lcd.print(t);
    lcd.print("f");
  }
}
