/* Gemaakt op 13 September 2012
  door Scott Fitzgerald http://arduino.cc/starterKit
  Deze voorbeeld-code is onderdeel van het publiek domein.
*/
#include <LiquidCrystal.h>
LiquidCrystal lcd(12, 11, 5, 4, 3, 2); // Pennen verbonden met lcd-scherm
const int switchPin = 6; // Pen verbonden met schakel-kantelaar
int switchState = 0;
int prevSwitchState = 0;
int reply;
void setup() {
  lcd.begin(16, 2);
  pinMode(switchPin, INPUT); // Stel pen-kantelaar in als input
  lcd.print("FORTUNE TELLER"); // Toon dit op regel 1
  lcd.setCursor(0, 1);
  lcd.print("Ask a Question"); // Toon dit op regel 2
}
void loop() {
  switchState = digitalRead(switchPin); // Lees pen kantel-schakelaar uit
  if (switchState != prevSwitchState) {
    if (switchState == LOW) { // als schakeling is onderbroken, geef antwoord
      reply = random(8); // Antwoord is 1 van 8 willekeurige gevallen zoals hieronder
      lcd.clear();
      lcd.setCursor(0, 0);
      lcd.print("The answer is: "); // Toon dit op het scherm
      lcd.setCursor(0, 1);
      switch (reply) { // Antwoord is een van de volgende gevallen
        case 0:
          lcd.print("Yes");
          break;
        case 1:
          lcd.print("Probably");
          break;
        case 2:
          lcd.print("Definitely");
          break;
        case 3:
          lcd.print("Don't be silly");
          break;
        case 4:
          lcd.print("Of course");
          break;
        case 5:
          lcd.print("Ask again");
          break;
        case 6:
          lcd.print("Doubtful");
          break;
        case 7:
          lcd.print("No");
          break;
      }
    }
  }
  prevSwitchState = switchState; // Reset de schakelaar
}
