// Gemaakt door Steven De Lannoy en gereproduceerd met vriendelijke toestemming
// http://www.wingbike.nl
// Een RGB-ledje met een gemeenschappelijke anode gebruikt (3 kathodes: R, G, B)
#include <LiquidCrystal.h>
LiquidCrystal lcd(12, 11, 5, 4, 3, 2);
int LEDR = 8; // Pen verbonden met rood ledje
int LEDB = 7; // Pen verbonden met blauw ledje
int LEDGr = 6; // Pen verbonden met groen ledje
int Button = 9; // Pen verbonden met drukknop
int COLOR; // Variabele kleur
int Beep;
int PSE; // Variabele pauze
int TME; // Tijd
int RTME = 0; // Reactietijd
void setup() {
  lcd.begin(16, 2);
  pinMode(LEDR, OUTPUT); // Stel led pennen in als output
  pinMode(LEDB, OUTPUT);
  pinMode(LEDGr, OUTPUT);
  pinMode(Button, INPUT); // Stel drukknoppen in als input
  digitalWrite(LEDR, LOW); // Schakel alle led-kleuren in
  digitalWrite(LEDB, LOW);
  digitalWrite(LEDGr, LOW);
}
void loop() {
  lcd.clear(); // Scherm wissen
  lcd.print("Hold Button to"); // Toon bericht op lcd-scherm
  lcd.setCursor(0, 1); // Ga naar de tweede regel
  lcd.print("start.");
  while (digitalRead(Button) == LOW) { // Test begint niet totdat
    // knop wordt ingedrukt (en gehouden)
    tone(13, 1200, 30);
    delay(1400);
    noTone(13);
  }
  lcd.clear();
  digitalWrite(LEDR, HIGH); // Schakel startlicht uit
  digitalWrite(LEDB, HIGH);
  digitalWrite(LEDGr, HIGH);
  randomSeed(analogRead(0)); // Willekeurig geluid van pen 0
  COLOR = random(1, 4); // Genereer willekeurige kleur
  PSE = random(500, 1200); // Stel willekeurige lengte van pauze tussen lichtjes in
  // Herhaal deze loop terwijl kleur groen of blauw is EN drukknop
  // wordt ingehouden
  while (COLOR != 1 && digitalRead(Button) == HIGH) {
    digitalWrite(LEDGr, HIGH);
    digitalWrite(LEDB, HIGH);
    delay(PSE);
    randomSeed(analogRead(0));
    Beep = random(1, 4); // Selecteer willekeurige piep van zoemer
    // (zoemer piept 1 van 3 keren)
    PSE = random(750, 1200); // Selecteer willekeurige lengte van pauze tussen
    // lichtjes (voor een groter verrassingseffect)
    if (Beep == 1) {
      tone(13, 1600, 350);
      delay(750);
      noTone(13);
    }
    if (COLOR == 2) {
      digitalWrite(LEDGr, LOW);
    }
    if (COLOR == 3) {
      digitalWrite(LEDB, LOW);
    }
    delay(PSE);
    randomSeed(analogRead(0));
    COLOR = random(1, 4); // Selecteer willekeurige kleur
  }
  // Voer deze loop uit als kleur rood is
  if (COLOR == 1 && digitalRead(Button) == HIGH) {
    digitalWrite(LEDGr, HIGH);
    digitalWrite(LEDB, HIGH);
    delay(PSE);
    TME = millis(); // Leg tijd vast sinds programma is begonnen
    digitalWrite(LEDR, LOW);
    while (digitalRead(Button) == HIGH) { // Wordt uitgevoerd totdat de knop
      // wordt losgelaten, en legt de 
      // reactietijd vast
      delay(1);
    }
    lcd.display();
    RTME = millis() - TME; // Reactietijd in milliseconden
    lcd.print("Reaction Time:"); // Toon op het lcd-scherm
    lcd.setCursor(0, 1);
    lcd.print(RTME);
  }
  // Voer uit als de kleur NIET rood is maar de drukknop los wordt gelaten
  if (COLOR != 1) {
    lcd.print("Released too");
    lcd.setCursor(0, 1); // Ga naar tweede regel
    lcd.print("soon!!!");
    tone(13, 3000, 1500);
    delay(500);
    noTone(13);
  }
  // Test begint niet opnieuw totdat de knop eenmaal wordt ingedrukt
  while (digitalRead(Button) == LOW) {
    delay(10);
  }
  digitalWrite(LEDR, LOW); // Reset alle lichtjes om opnieuw te beginnen
  digitalWrite(LEDB, LOW);
  digitalWrite(LEDGr, LOW);
  lcd.clear();
  lcd.print("Hold Button to");
  lcd.setCursor(0, 1);
  lcd.print("start.");
  int Time = 0;
  delay(1000);
}
