// Ardunaut, Arduining.com, gereproduceerd met vriendelijke toestemming
#define FuseTIME 1500 // Duur van stroom zekering in miliseconden
#include <SoftwareSerial.h> // Roep de SoftwareSerial-bibliotheek aan
#define Fuse 7 // Pen verbonden met zekering (je ledje of ontsteking)
#define GoButt 6 // Pen verbonden met lanceerknop
#define ArmButt 5 // Pen verbonden met knop Op scherp
#define BuzzPin 4 // Pen verbonden met piëzo zoemer
#define TXdata 3 // Pen verbonden met RX van het scherm
#define RXdata 2 // Niet in gebruik
#define SetPot 0 // Analoge pen verbonden met potentiometer
SoftwareSerial mySerialPort(RXdata, TXdata);
void setup() {
  pinMode(TXdata, OUTPUT);
  pinMode(RXdata, INPUT);
  pinMode(Fuse, OUTPUT);
  pinMode(ArmButt, INPUT); // Stel pen van knop Op scherp in als input
  pinMode(GoButt, INPUT); // Stel pen van knop Lanceren in als input
  digitalWrite(Fuse, LOW); // Open ontstekings-schakeling
  digitalWrite(ArmButt, HIGH); // Schakel weerstand in
  digitalWrite(GoButt, HIGH); // Schakel weerstand in
  mySerialPort.begin(9600);
  delay(10); // Wacht op opstarten van seriële scherm
  mySerialPort.print("v"); // Reset het seriële scherm
  mySerialPort.print("z"); // Helderheid
  mySerialPort.write(0x40); // 3/4 intensiteit
  mySerialPort.print("w"); // Aansturen van decimale punt
  mySerialPort.write(0x10); // Schakel dubbele punt in op seriële scherm
}
int DownCntr; // AFtellen (1/10 seconden)
int Go = 0; // Gestopt
void loop() {
  if (!digitalRead(GoButt) || !digitalRead(ArmButt)) {
    Go = 0; // Aftellen afbreken
    tone(BuzzPin, 440, 1500);
    delay(1500);
  }
  if (Go == 0) {
    WaitARM();
    WaitGO();
  }
  ShowTimer();
  if (DownCntr > 50) {
    if (DownCntr % 10 == 0)tone(BuzzPin, 1000, 50); // One piep/seconde
  }
  else if (DownCntr % 2 == 0)tone(BuzzPin, 1000, 50); // Sneller piepen
  if (DownCntr == 0) {
    tone(BuzzPin, 440, FuseTIME); // Lanceer-toon
    digitalWrite(Fuse, HIGH); // Sluit zekering schakeling
    delay(FuseTIME);
    digitalWrite(Fuse, LOW); // Open zekering schakeling
    Go = 0;
  }
  while (millis() % 100); // Wacht 50 ms
  delay(50);
  DownCntr--;
}
void WaitGO() {
  ShowTimer();
  while (digitalRead(GoButt));
  Go = 1;
  delay(20);
  while (!digitalRead(GoButt)); // Knop Lanceren terug laten veren
}
void ReadTimer() {
  DownCntr = map(analogRead(SetPot), 0, 1023, 5, 60);
  DownCntr *= 10;
}
void ShowTimer() {
  String seconds = String (DownCntr, DEC);
  while (seconds.length() < 3)seconds = "0" + seconds; // STel in op
  // 3 getallen
  mySerialPort.print(seconds); // Toon op seriële scherm
  mySerialPort.print(" "); // Laatste cijfer uit
}
void WaitARM() {
  while (digitalRead(ArmButt) == 1) {
    ReadTimer();
    delay(50);
    ReadTimer();
    ShowTimer();
    delay(150);
  }
  Go = 0;
  ShowTimer();
  tone(BuzzPin, 2000, 150);
  delay(200);
  tone(BuzzPin, 2000, 150);
  delay(200);
  tone(BuzzPin, 2000, 150);
  delay(20);
  while (!digitalRead(ArmButt)); // Knop Op scherp terug laten veren
}
