int ledPin = 13; // Pen verbonden aan het ledje
int inputPin = 2; // Pen verbonden aan de PIR-sensor
int pirState = LOW; // Start PIR-status LOW zonder beweging
int val = 0; // Variabele om de pen-status uit te lezen
int pinSpeaker = 10; // Pen verbonden met piëzo
void setup() {
  pinMode(ledPin, OUTPUT); // Stel ledje in als output
  pinMode(inputPin, INPUT); // Stel sensor in als input
  pinMode(pinSpeaker, OUTPUT);
  Serial.begin(9600);
}
void loop() {
  val = digitalRead(inputPin); // Lees PIR input waarde uit
  if (val == HIGH) { // Controleer of input HIGH is
    digitalWrite(ledPin, HIGH); // Als dat zo is, zet dan het ledje AAN
    playTone(300, 160);
    delay(150);
    if (pirState == LOW) {
      // Toon in de Seriële Moniter als er beweging gedetecteerd is
      Serial.println("Motion detected!");
      pirState = HIGH;
    }
  } else {
    digitalWrite(ledPin, LOW); // Als input niet HIGH is,
    // zet dan het ledje UIT
    playTone(0, 0);
    delay(300);
    if (pirState == HIGH) {
      Serial.println("Motion ended!");
      pirState = LOW;
    }
  }
}
void playTone(long duration, int freq) { // Duur in ms,
  // frequentie in Hz
  duration *= 1000;
  int period = (1.0 / freq) * 1000000;
  long elapsed_time = 0;
  while (elapsed_time < duration) {
    digitalWrite(pinSpeaker, HIGH);
    delayMicroseconds(period / 2);
    digitalWrite(pinSpeaker, LOW);
    delayMicroseconds(period / 2);
    elapsed_time += (period);
  }
}
