// Keypad bibliotheek voor Arduino
// Auteurs:  Mark Stanley, Alexander Brevig
// http://playground.arduino.cc/Main/KeypadTutorial

#include <Password.h>
#include <Keypad.h>
#include <Servo.h>
Servo myservo;
Password password = Password( "2468" ); // Stel wachtwoord in als 2468
const byte ROWS = 4; // stel vier rijen in
const byte COLS = 4; // stel vier kolommen in
char keys[ROWS][COLS] = { // Definieer de toetsenindeling
  {'1', '2', '3', 'A'},
  {'4', '5', '6', 'B'},
  {'7', '8', '9', 'C'},
  {'*', '0', '#', 'D'}
};
byte rowPins[ROWS] = { 9, 8, 7, 6 }; // Pennen verbonden met het toetsenblok
// ROW0, ROW1, ROW2 en ROW3
byte colPins[COLS] = { 5, 4, 3, 2, }; // Pennen verbonden met het toetsenblok
// COL0, COL1 en COL2
// Creëer het toetsenblok
Keypad keypad = Keypad( makeKeymap(keys), rowPins, colPins,
                        ROWS, COLS );
void setup() {
  Serial.begin(9600);
  delay(200);
  pinMode(11, OUTPUT); // Stel groen ledje in als output
  pinMode(12, OUTPUT); // Stel rood ledje in als output
  myservo.attach(13); // Pen verbonden met servo
  keypad.addEventListener(keypadEvent); // Voeg een code die gebeurtenissen oppikt toe
  // om ingedrukte toetsen te detecteren
}
void loop() {
  keypad.getKey();
  myservo.write(0);
}
void keypadEvent(KeypadEvent eKey) {
  switch (keypad.getState()) {
    case PRESSED:
      Serial.print("Pressed: ");
      Serial.println(eKey);
      switch (eKey) {
        case '*': checkPassword(); break;
        case '#': password.reset(); break;
        default: password.append(eKey);
      }
  }
}
void checkPassword() {
  if (password.evaluate() ) {
    Serial.println("Success"); // Als het wachtwoord correct is...
    myservo.write(90); // Beweeg servo-arm 90 graden
    digitalWrite(11, HIGH); // Zet groene ledje aan
    delay(500); // Wacht 5 seconden
    digitalWrite(11, LOW); // Zet groede ledje uit
  } else {
    Serial.println("Wrong"); // Als het wachtwoord incorrect is...
    myservo.write(0);
    digitalWrite(12, HIGH); // Zet rode ledje aan
    delay(500); // Wacht 5 seconden
    digitalWrite(12, LOW); // Zet rode ledje uit
  }
}
