/*
  Voorbeeld 18.1 - Experimenteren met RGB LED matrix
  CC by-sa 3.0
  http://tronixstuff.wordpress.com/tutorials
*/
int latchpin = 10; // Verbind met pen 12 op alle schuifregisters
int clockpin = 13; // Verbind met pen 11 op alle schuifregisters
int datapin = 11; // Verbind met pen 14 op schuifregister 2
int zz = 500; // Vertragings-variabele
int va[] = {
  1, 2, 4, 8, 16, 32, 64, 128, 255
};
int va2[] = {
  1, 3, 7, 15, 31, 63, 127, 255
};
void setup() {
  pinMode(latchpin, OUTPUT);
  pinMode(clockpin, OUTPUT);
  pinMode(datapin, OUTPUT);
  digitalWrite(latchpin, LOW);
  shiftOut(datapin, clockpin, MSBFIRST, 0);
  shiftOut(datapin, clockpin, MSBFIRST, 0);
  shiftOut(datapin, clockpin, MSBFIRST, 0);
  shiftOut(datapin, clockpin, MSBFIRST, 0);
  digitalWrite(latchpin, HIGH);
  randomSeed(analogRead(0));
}
void allRed() { // Zet alle rode ledjes aan
  digitalWrite(latchpin, LOW);
  shiftOut(datapin, clockpin, MSBFIRST, 255); // Zet kathoden op vol
  shiftOut(datapin, clockpin, MSBFIRST, 0); // Zet groen op 0
  shiftOut(datapin, clockpin, MSBFIRST, 0); // Zet blauw op 0
  shiftOut(datapin, clockpin, MSBFIRST, 255); // Zet rood op vol
  digitalWrite(latchpin, HIGH);
}
void allBlue() { // Zet alle blauwe ledjes aan
  digitalWrite(latchpin, LOW);
  shiftOut(datapin, clockpin, MSBFIRST, 255); // Turn cathodes to full
  shiftOut(datapin, clockpin, MSBFIRST, 0); // Turn green to 0
  shiftOut(datapin, clockpin, MSBFIRST, 255); // Turn blue to full
  shiftOut(datapin, clockpin, MSBFIRST, 0); // Turn red to 0
  digitalWrite(latchpin, HIGH);
}
void allGreen() { // Zet alle groene ledjes aan
  digitalWrite(latchpin, LOW);
  shiftOut(datapin, clockpin, MSBFIRST, 255); // Kathoden
  shiftOut(datapin, clockpin, MSBFIRST, 255); // Groen
  shiftOut(datapin, clockpin, MSBFIRST, 0); // Blauw
  shiftOut(datapin, clockpin, MSBFIRST, 0); // Rood
  digitalWrite(latchpin, HIGH);
}
void allOn() { // Zet alle ledjes aan
  digitalWrite(latchpin, LOW);
  shiftOut(datapin, clockpin, MSBFIRST, 255); // Kathoden
  shiftOut(datapin, clockpin, MSBFIRST, 255); // Groen
  shiftOut(datapin, clockpin, MSBFIRST, 255); // Blauw
  shiftOut(datapin, clockpin, MSBFIRST, 255); // Rood
  digitalWrite(latchpin, HIGH);
}
void allYellow() { // Zet groene en rode ledjes aan (geel)
  digitalWrite(latchpin, LOW);
  shiftOut(datapin, clockpin, MSBFIRST, 255); // Kathoden
  shiftOut(datapin, clockpin, MSBFIRST, 255); // Groen
  shiftOut(datapin, clockpin, MSBFIRST, 0); // Blauw
  shiftOut(datapin, clockpin, MSBFIRST, 255); // Rood
  digitalWrite(latchpin, HIGH);
}
void allAqua() { // Zet groene en blauwe ledjes aan (aqua)
  digitalWrite(latchpin, LOW);
  shiftOut(datapin, clockpin, MSBFIRST, 255); // Kathoden
  shiftOut(datapin, clockpin, MSBFIRST, 255); // Groen
  shiftOut(datapin, clockpin, MSBFIRST, 255); // Blauw
  shiftOut(datapin, clockpin, MSBFIRST, 0); // Rood
  digitalWrite(latchpin, HIGH);
}
void allPurple() { // Zet blauwe en rode ledjes aan (paars)
  digitalWrite(latchpin, LOW);
  shiftOut(datapin, clockpin, MSBFIRST, 255); // Kathoden
  shiftOut(datapin, clockpin, MSBFIRST, 0); // Groen
  shiftOut(datapin, clockpin, MSBFIRST, 255); // Blauw
  shiftOut(datapin, clockpin, MSBFIRST, 255); // Rood
  digitalWrite(latchpin, HIGH);
}
void clearMatrix() { // Zet alle ledjes uit
  digitalWrite(latchpin, LOW);
  shiftOut(datapin, clockpin, MSBFIRST, 0); // Kathoden
  shiftOut(datapin, clockpin, MSBFIRST, 0); // Groen
  shiftOut(datapin, clockpin, MSBFIRST, 0); // Blauw
  shiftOut(datapin, clockpin, MSBFIRST, 0); // Rood
  digitalWrite(latchpin, HIGH);
}
void lostinspace() { // Willekeurig flitsen van de ledjes
  for (int z = 0; z < 100; z++) {
    digitalWrite(latchpin, LOW);
    shiftOut(datapin, clockpin, MSBFIRST, va[random(8)]); // Kathoden
    shiftOut(datapin, clockpin, MSBFIRST, va[random(8)]); // Groen
    shiftOut(datapin, clockpin, MSBFIRST, va[random(8)]); // Blauw
    shiftOut(datapin, clockpin, MSBFIRST, va[random(8)]); // Rood
    digitalWrite(latchpin, HIGH);
    delay(100);
  }
}
void displayLEDs(int rr, int gg, int bb, int cc, int dd) {
  // Voeg de base-10 waarden toe aan de shiftOut functies
  // en houd het display dd milliseconden vast
  digitalWrite(latchpin, LOW);
  shiftOut(datapin, clockpin, MSBFIRST, cc); // Kathoden
  shiftOut(datapin, clockpin, MSBFIRST, gg); // Groen
  shiftOut(datapin, clockpin, MSBFIRST, bb); // Blauw
  shiftOut(datapin, clockpin, MSBFIRST, rr); // Rood
  digitalWrite(latchpin, HIGH);
  delay(dd);
}
void loop() { // Het hele scherm in effen kleuren oplichten
  allOn();
  delay(zz);
  delay(zz);
  allRed();
  delay(zz);
  delay(zz);
  allGreen();
  delay(zz);
  delay(zz);
  allBlue();
  delay(zz);
  delay(zz);
  allPurple();
  delay(zz);
  delay(zz);
  allYellow();
  delay(zz);
  delay(zz);
  allAqua();
  delay(1000);
  // Enkele individuele ledjes oplichten met willekeurige waarden
  lostinspace(); // Enkele horizontale en verticale regels schuiven
  for (int z = 0; z < 5; z++) {
    for (int q = 1; q < 129; q *= 2) {
      displayLEDs(255, 0, 0, q, 200);
    }
  }
  clearMatrix();
  delay(1000);
  for (int z = 0; z < 5; z++) {
    for (int q = 1; q < 129; q *= 2) {
      displayLEDs(0, 255, 0, q, 200);
      displayLEDs(q, 0, 0, 255, 200);
    }
  }
  clearMatrix();
  delay(1000);
  for (int z = 0; z < 5; z++) {
    for (int q = 1; q < 9; q++) {
      displayLEDs(0, 0, 255, va2[q], 200);
    }
  }
  clearMatrix();
  delay(1000);
}
